
import matplotlib.pyplot as plt
import matplotlib.colors as colors
import numpy as np
import math


''' Aufgabe 2 '''


def convolve(image, matrix):
           
        # Neues Bild anlegen:
        h, w = image.shape
        result = np.zeros((h, w))        
        
        # Alle Pixel durchgehen:
        for y in xrange(h):
            for x in xrange(w):
                result[y, x] = convolveAt(image, x, y, matrix)
        
        # Ergebnis zurueckgeben:
        return result
    
    
def convolveAt(image, x, y, matrix):
        h, w = image.shape
        m, n = matrix.shape
        m = int(math.floor(m/2))
        n = int(math.floor(n/2))
        sum = 0
        for my in xrange(-m, m+1):
            for mx in xrange(-n, n+1):
                sum += matrix[my+m, mx+n] * image[max(0, min(h-1, y + my)), max(0, min(w-1, x + mx))]
        return sum



def unsharp_mask(input, r=1, d=0, k=1):
    
    n = 2*r+1
    
    #1. Unscharfe Version erzeugen:
    matrix = np.ones((n, n))
    matrix *= 1.0/(n*n)
    input_blurred = convolve(input, matrix)
    
    #2. Maske erzeugen:
    mask = np.zeros_like(input)
    h, w = input.shape
    for y in xrange(h):
        for x in xrange(w):
            diff = input[y, x] - input_blurred[y, x]
            # Anmerkung: Ich habe die Angabe so verstanden, 
            # dass die Differenz in beide Richtungen > d sein soll.
            # Daher habe ich hier den Betrag genommen. 
            if(abs(diff) > d):
                mask[y, x] = diff
    
    #3. Maske (anteilig) addieren:
    result = input + k * mask
       
    return result, mask



def unsharp_mask_single_kernel(input, r=1, k=1):
    
    n = 2*r+1
    
    dirac_delta = np.zeros((n, n))
    dirac_delta[n/2, n/2] += 1
    
    blur_kernel = np.ones((n, n))
    blur_kernel *= 1.0/(n*n)
       
    kernel = (k + 1) * dirac_delta - k * blur_kernel
      
    result = convolve(input, kernel)           
    return result
    
    
    
input = plt.imread('ente.png')
result, mask = unsharp_mask(input, 1, 0, 1.5) #Algorithmus von Teilaufgabe b): 3-Schritte Algorithmus, inkl. Parameter d.
result2 = unsharp_mask_single_kernel(input, 1, 1.5) #Algorithmus zu Teilaufgabe a): Nur ein einzelner Kern. 
#Wie man sieht fuehren beide Wege zum gleichen Ergebnis. :)
plt.figure(1)
plt.subplot(221)
plt.title("Original")
plt.imshow(input, cmap=plt.cm.gray,norm=colors.NoNorm())
plt.subplot(222)
plt.title("Mask")
plt.imshow(mask, cmap=plt.cm.gray)
plt.subplot(223)
plt.title("Result: 3-Step Algorithm (b)")
plt.imshow(result, cmap=plt.cm.gray, norm=colors.NoNorm())
plt.subplot(224)
plt.title("Result: Single Kernel (a)")
plt.imshow(result2, cmap=plt.cm.gray, norm=colors.NoNorm())
plt.show()
    